//
// Simple Shoot
// Copyright (C) 2010-2011 Xavier MICHEL (xavier.michel.mx440@gmail.com)
//
// This software is provided as-is, without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//

#ifndef CSINGLETON_HPP
#define CSINGLETON_HPP

#include "constantes.hpp"

/*!
    \class Singleton
    \brief Modèle singleton applicable à n'importe quelle classe.
*/

template <typename T> class Singleton {

protected:
    Singleton ();
    ~Singleton ();

public:

    /*!
        \brief Obtient l'instance de T
   */
    static T *getInstance ();

    /*!
        \brief Destruction de l'instance de T
    */
    static void kill ();

private:

    /*!
        \brief Unique instance
    */
    static T *m_singleton;

};

#include "Singleton.inl"

#endif // CSINGLETON_HPP
