//
// Simple Shoot
// Copyright (C) 2010-2011 Xavier MICHEL (xavier.michel.mx440@gmail.com)
//
// This software is provided as-is, without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//

template <typename T> T* Singleton<T>::m_singleton = 0;

template <class T> Singleton<T>::Singleton() {
}

template <class T> Singleton<T>::~Singleton() {
}

template <class T> T* Singleton<T>::getInstance () {
  if ( ! m_singleton ) {
      m_singleton = new T;
  }

  return (static_cast<T*> (m_singleton));
}


template <class T> void Singleton<T>::kill () {
  if ( m_singleton )
    {
      delete m_singleton;
      m_singleton = 0;
    }
}

